// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2023 Levente Bajczi, Department of Measurement and Information Systems, Budapest University of Technology and Economics
//
// SPDX-License-Identifier: Apache-2.0

// Original CHC file: eldarica-misc/38.c_001.smt2
extern void abort ();
extern int __VERIFIER_nondet_int ();
extern _Bool __VERIFIER_nondet__Bool ();
extern void __assert_fail(const char *, const char *, unsigned int, const char *) __attribute__ ((__nothrow__ , __leaf__)) __attribute__ ((__noreturn__));
void reach_error() { __assert_fail("0", "38.c_001_norange.c", 13, "reach_error"); }



int main ();

int
main ()
{
    // return parameter


    // variables
    int h4_0;
    int h4_1;
    int h4_2;
    int h4_3;
    int h4_4;
    int h4_5;
    int h4_6;
    int h4_7;
    int h19_0;
    int h19_1;
    int h19_2;
    int h19_3;
    int h19_4;
    int h19_5;
    int h19_6;
    int h19_7;
    int h15_0;
    int h15_1;
    int h15_2;
    int h15_3;
    int h15_4;
    int h15_5;
    int h15_6;
    int h15_7;
    int h14_0;
    int h14_1;
    int h14_2;
    int h14_3;
    int h14_4;
    int h14_5;
    int h14_6;
    int h14_7;
    int h24_0;
    int h24_1;
    int h24_2;
    int h24_3;
    int h24_4;
    int h24_5;
    int h24_6;
    int h24_7;
    int h6_0;
    int h6_1;
    int h6_2;
    int h6_3;
    int h6_4;
    int h6_5;
    int h6_6;
    int h6_7;
    int h2_0;
    int h2_1;
    int h2_2;
    int h2_3;
    int h2_4;
    int h2_5;
    int h2_6;
    int h2_7;
    int h18_0;
    int h18_1;
    int h18_2;
    int h18_3;
    int h18_4;
    int h18_5;
    int h18_6;
    int h18_7;
    int h1_0;
    int h1_1;
    int h1_2;
    int h1_3;
    int h1_4;
    int h1_5;
    int h1_6;
    int h1_7;
    int h8_0;
    int h8_1;
    int h8_2;
    int h8_3;
    int h8_4;
    int h8_5;
    int h8_6;
    int h8_7;
    int h13_0;
    int h13_1;
    int h13_2;
    int h13_3;
    int h13_4;
    int h13_5;
    int h13_6;
    int h13_7;
    int h12_0;
    int h12_1;
    int h12_2;
    int h12_3;
    int h12_4;
    int h12_5;
    int h12_6;
    int h12_7;
    int h10_0;
    int h10_1;
    int h10_2;
    int h10_3;
    int h10_4;
    int h10_5;
    int h10_6;
    int h10_7;
    int h7_0;
    int h7_1;
    int h7_2;
    int h7_3;
    int h7_4;
    int h7_5;
    int h7_6;
    int h7_7;
    int h17_0;
    int h17_1;
    int h17_2;
    int h17_3;
    int h17_4;
    int h17_5;
    int h17_6;
    int h17_7;
    int h16_0;
    int h16_1;
    int h16_2;
    int h16_3;
    int h16_4;
    int h16_5;
    int h16_6;
    int h16_7;
    int h3_0;
    int h3_1;
    int h3_2;
    int h3_3;
    int h3_4;
    int h3_5;
    int h3_6;
    int h3_7;
    int h9_0;
    int h9_1;
    int h9_2;
    int h9_3;
    int h9_4;
    int h9_5;
    int h9_6;
    int h9_7;
    int h11_0;
    int h11_1;
    int h11_2;
    int h11_3;
    int h11_4;
    int h11_5;
    int h11_6;
    int h11_7;
    int h5_0;
    int h5_1;
    int h5_2;
    int h5_3;
    int h5_4;
    int h5_5;
    int h5_6;
    int h5_7;
    int A_0;
    int B_0;
    int C_0;
    int D_0;
    int v_4_0;
    int v_5_0;
    int v_6_0;
    int v_7_0;
    int A_1;
    int B_1;
    int C_1;
    int D_1;
    int E_1;
    int F_1;
    int G_1;
    int H_1;
    int I_1;
    int J_1;
    int K_1;
    int A_2;
    int B_2;
    int C_2;
    int D_2;
    int E_2;
    int F_2;
    int G_2;
    int H_2;
    int A_3;
    int B_3;
    int C_3;
    int D_3;
    int E_3;
    int F_3;
    int G_3;
    int H_3;
    int A_4;
    int B_4;
    int C_4;
    int D_4;
    int E_4;
    int F_4;
    int G_4;
    int H_4;
    int A_5;
    int B_5;
    int C_5;
    int D_5;
    int E_5;
    int F_5;
    int G_5;
    int H_5;
    int A_6;
    int B_6;
    int C_6;
    int D_6;
    int E_6;
    int F_6;
    int G_6;
    int H_6;
    int A_7;
    int B_7;
    int C_7;
    int D_7;
    int E_7;
    int F_7;
    int G_7;
    int H_7;
    int A_8;
    int B_8;
    int C_8;
    int D_8;
    int E_8;
    int F_8;
    int G_8;
    int H_8;
    int A_9;
    int B_9;
    int C_9;
    int D_9;
    int E_9;
    int F_9;
    int G_9;
    int H_9;
    int A_10;
    int B_10;
    int C_10;
    int D_10;
    int E_10;
    int F_10;
    int G_10;
    int H_10;
    int I_10;
    int J_10;
    int A_11;
    int B_11;
    int C_11;
    int D_11;
    int E_11;
    int F_11;
    int G_11;
    int H_11;
    int A_12;
    int B_12;
    int C_12;
    int D_12;
    int E_12;
    int F_12;
    int G_12;
    int H_12;
    int A_13;
    int B_13;
    int C_13;
    int D_13;
    int E_13;
    int F_13;
    int G_13;
    int H_13;
    int A_14;
    int B_14;
    int C_14;
    int D_14;
    int E_14;
    int F_14;
    int G_14;
    int H_14;
    int A_15;
    int B_15;
    int C_15;
    int D_15;
    int E_15;
    int F_15;
    int G_15;
    int H_15;
    int A_16;
    int B_16;
    int C_16;
    int D_16;
    int E_16;
    int F_16;
    int G_16;
    int H_16;
    int I_16;
    int A_17;
    int B_17;
    int C_17;
    int D_17;
    int E_17;
    int F_17;
    int G_17;
    int H_17;
    int A_18;
    int B_18;
    int C_18;
    int D_18;
    int E_18;
    int F_18;
    int G_18;
    int H_18;
    int A_19;
    int B_19;
    int C_19;
    int D_19;
    int E_19;
    int F_19;
    int G_19;
    int H_19;
    int A_20;
    int B_20;
    int C_20;
    int D_20;
    int E_20;
    int F_20;
    int G_20;
    int H_20;
    int A_21;
    int B_21;
    int C_21;
    int D_21;
    int E_21;
    int F_21;
    int G_21;
    int H_21;
    int A_23;
    int B_23;
    int C_23;
    int D_23;
    int E_23;
    int F_23;
    int G_23;
    int H_23;
    int A_24;
    int B_24;
    int C_24;
    int D_24;
    int E_24;
    int F_24;
    int G_24;
    int H_24;



    // main logic
    goto main_init;

  main_init:
    if (!
        ((v_4_0 == A_0) && (v_5_0 == B_0) && (v_6_0 == C_0)
         && (v_7_0 == D_0)))
        abort ();
    h1_0 = A_0;
    h1_1 = B_0;
    h1_2 = C_0;
    h1_3 = D_0;
    h1_4 = v_4_0;
    h1_5 = v_5_0;
    h1_6 = v_6_0;
    h1_7 = v_7_0;
    F_1 = __VERIFIER_nondet_int ();
    G_1 = __VERIFIER_nondet_int ();
    H_1 = __VERIFIER_nondet_int ();
    A_1 = h1_0;
    B_1 = h1_1;
    C_1 = h1_2;
    D_1 = h1_3;
    E_1 = h1_4;
    I_1 = h1_5;
    J_1 = h1_6;
    K_1 = h1_7;
    if (!((F_1 == 0) && (H_1 == 0) && (G_1 == 0)))
        abort ();
    h2_0 = A_1;
    h2_1 = B_1;
    h2_2 = C_1;
    h2_3 = D_1;
    h2_4 = E_1;
    h2_5 = F_1;
    h2_6 = G_1;
    h2_7 = H_1;
    A_2 = h2_0;
    B_2 = h2_1;
    C_2 = h2_2;
    D_2 = h2_3;
    E_2 = h2_4;
    F_2 = h2_5;
    G_2 = h2_6;
    H_2 = h2_7;
    if (!1)
        abort ();
    h3_0 = A_2;
    h3_1 = B_2;
    h3_2 = C_2;
    h3_3 = D_2;
    h3_4 = E_2;
    h3_5 = F_2;
    h3_6 = G_2;
    h3_7 = H_2;
    A_3 = h3_0;
    B_3 = h3_1;
    C_3 = h3_2;
    D_3 = h3_3;
    E_3 = h3_4;
    F_3 = h3_5;
    G_3 = h3_6;
    H_3 = h3_7;
    if (!1)
        abort ();
    h4_0 = A_3;
    h4_1 = B_3;
    h4_2 = C_3;
    h4_3 = D_3;
    h4_4 = E_3;
    h4_5 = F_3;
    h4_6 = G_3;
    h4_7 = H_3;
    A_4 = h4_0;
    B_4 = h4_1;
    C_4 = h4_2;
    D_4 = h4_3;
    E_4 = h4_4;
    F_4 = h4_5;
    G_4 = h4_6;
    H_4 = h4_7;
    if (!1)
        abort ();
    h5_0 = A_4;
    h5_1 = B_4;
    h5_2 = C_4;
    h5_3 = D_4;
    h5_4 = E_4;
    h5_5 = F_4;
    h5_6 = G_4;
    h5_7 = H_4;
    A_8 = h5_0;
    B_8 = h5_1;
    C_8 = h5_2;
    D_8 = h5_3;
    E_8 = h5_4;
    F_8 = h5_5;
    G_8 = h5_6;
    H_8 = h5_7;
    if (!1)
        abort ();
    h6_0 = A_8;
    h6_1 = B_8;
    h6_2 = C_8;
    h6_3 = D_8;
    h6_4 = E_8;
    h6_5 = F_8;
    h6_6 = G_8;
    h6_7 = H_8;
    goto h6;
  main_error:
    reach_error ();
  main_final:
    goto main_final;
  h6:
    switch (__VERIFIER_nondet__Bool ())
      {
      case 0:
          A_9 = h6_0;
          B_9 = h6_1;
          C_9 = h6_2;
          D_9 = h6_3;
          E_9 = h6_4;
          F_9 = h6_5;
          G_9 = h6_6;
          H_9 = h6_7;
          if (!((E_9 + (-1 * H_9)) >= 1))
              abort ();
          h7_0 = A_9;
          h7_1 = B_9;
          h7_2 = C_9;
          h7_3 = D_9;
          h7_4 = E_9;
          h7_5 = F_9;
          h7_6 = G_9;
          h7_7 = H_9;
          F_10 = __VERIFIER_nondet_int ();
          H_10 = __VERIFIER_nondet_int ();
          A_10 = h7_0;
          B_10 = h7_1;
          C_10 = h7_2;
          D_10 = h7_3;
          E_10 = h7_4;
          J_10 = h7_5;
          G_10 = h7_6;
          I_10 = h7_7;
          if (!((I_10 == (H_10 + -1)) && (J_10 == (F_10 + -1))))
              abort ();
          h8_0 = A_10;
          h8_1 = B_10;
          h8_2 = C_10;
          h8_3 = D_10;
          h8_4 = E_10;
          h8_5 = F_10;
          h8_6 = G_10;
          h8_7 = H_10;
          A_14 = h8_0;
          B_14 = h8_1;
          C_14 = h8_2;
          D_14 = h8_3;
          E_14 = h8_4;
          F_14 = h8_5;
          G_14 = h8_6;
          H_14 = h8_7;
          if (!1)
              abort ();
          h12_0 = A_14;
          h12_1 = B_14;
          h12_2 = C_14;
          h12_3 = D_14;
          h12_4 = E_14;
          h12_5 = F_14;
          h12_6 = G_14;
          h12_7 = H_14;
          goto h12;

      case 1:
          A_11 = h6_0;
          B_11 = h6_1;
          C_11 = h6_2;
          D_11 = h6_3;
          E_11 = h6_4;
          F_11 = h6_5;
          G_11 = h6_6;
          H_11 = h6_7;
          if (!((E_11 + (-1 * H_11)) <= 0))
              abort ();
          h9_0 = A_11;
          h9_1 = B_11;
          h9_2 = C_11;
          h9_3 = D_11;
          h9_4 = E_11;
          h9_5 = F_11;
          h9_6 = G_11;
          h9_7 = H_11;
          A_12 = h9_0;
          B_12 = h9_1;
          C_12 = h9_2;
          D_12 = h9_3;
          E_12 = h9_4;
          F_12 = h9_5;
          G_12 = h9_6;
          H_12 = h9_7;
          if (!1)
              abort ();
          h10_0 = A_12;
          h10_1 = B_12;
          h10_2 = C_12;
          h10_3 = D_12;
          h10_4 = E_12;
          h10_5 = F_12;
          h10_6 = G_12;
          h10_7 = H_12;
          A_13 = h10_0;
          B_13 = h10_1;
          C_13 = h10_2;
          D_13 = h10_3;
          E_13 = h10_4;
          F_13 = h10_5;
          G_13 = h10_6;
          H_13 = h10_7;
          if (!1)
              abort ();
          h11_0 = A_13;
          h11_1 = B_13;
          h11_2 = C_13;
          h11_3 = D_13;
          h11_4 = E_13;
          h11_5 = F_13;
          h11_6 = G_13;
          h11_7 = H_13;
          A_19 = h11_0;
          B_19 = h11_1;
          C_19 = h11_2;
          D_19 = h11_3;
          E_19 = h11_4;
          F_19 = h11_5;
          G_19 = h11_6;
          H_19 = h11_7;
          if (!1)
              abort ();
          h17_0 = A_19;
          h17_1 = B_19;
          h17_2 = C_19;
          h17_3 = D_19;
          h17_4 = E_19;
          h17_5 = F_19;
          h17_6 = G_19;
          h17_7 = H_19;
          A_20 = h17_0;
          B_20 = h17_1;
          C_20 = h17_2;
          D_20 = h17_3;
          E_20 = h17_4;
          F_20 = h17_5;
          G_20 = h17_6;
          H_20 = h17_7;
          if (!(((H_20 % 2 + 2) % 2) == 0))
              abort ();
          h18_0 = A_20;
          h18_1 = B_20;
          h18_2 = C_20;
          h18_3 = D_20;
          h18_4 = E_20;
          h18_5 = F_20;
          h18_6 = G_20;
          h18_7 = H_20;
          A_21 = h18_0;
          B_21 = h18_1;
          C_21 = h18_2;
          D_21 = h18_3;
          E_21 = h18_4;
          F_21 = h18_5;
          G_21 = h18_6;
          H_21 = h18_7;
          if (!1)
              abort ();
          h19_0 = A_21;
          h19_1 = B_21;
          h19_2 = C_21;
          h19_3 = D_21;
          h19_4 = E_21;
          h19_5 = F_21;
          h19_6 = G_21;
          h19_7 = H_21;
          A_23 = h19_0;
          B_23 = h19_1;
          C_23 = h19_2;
          D_23 = h19_3;
          E_23 = h19_4;
          F_23 = h19_5;
          G_23 = h19_6;
          H_23 = h19_7;
          if (!((F_23 + (-2 * G_23)) >= 1))
              abort ();
          h24_0 = A_23;
          h24_1 = B_23;
          h24_2 = C_23;
          h24_3 = D_23;
          h24_4 = E_23;
          h24_5 = F_23;
          h24_6 = G_23;
          h24_7 = H_23;
          A_24 = h24_0;
          B_24 = h24_1;
          C_24 = h24_2;
          D_24 = h24_3;
          E_24 = h24_4;
          F_24 = h24_5;
          G_24 = h24_6;
          H_24 = h24_7;
          if (!1)
              abort ();
          goto main_error;

      default:
          abort ();
      }
  h12:
    switch (__VERIFIER_nondet_int ())
      {
      case 0:
          A_17 = h12_0;
          B_17 = h12_1;
          C_17 = h12_2;
          D_17 = h12_3;
          E_17 = h12_4;
          F_17 = h12_5;
          G_17 = h12_6;
          H_17 = h12_7;
          if (!(!(((H_17 % 2 + 2) % 2) == 0)))
              abort ();
          h15_0 = A_17;
          h15_1 = B_17;
          h15_2 = C_17;
          h15_3 = D_17;
          h15_4 = E_17;
          h15_5 = F_17;
          h15_6 = G_17;
          h15_7 = H_17;
          A_5 = h15_0;
          B_5 = h15_1;
          C_5 = h15_2;
          D_5 = h15_3;
          E_5 = h15_4;
          F_5 = h15_5;
          G_5 = h15_6;
          H_5 = h15_7;
          if (!1)
              abort ();
          h5_0 = A_5;
          h5_1 = B_5;
          h5_2 = C_5;
          h5_3 = D_5;
          h5_4 = E_5;
          h5_5 = F_5;
          h5_6 = G_5;
          h5_7 = H_5;
          A_8 = h5_0;
          B_8 = h5_1;
          C_8 = h5_2;
          D_8 = h5_3;
          E_8 = h5_4;
          F_8 = h5_5;
          G_8 = h5_6;
          H_8 = h5_7;
          if (!1)
              abort ();
          h6_0 = A_8;
          h6_1 = B_8;
          h6_2 = C_8;
          h6_3 = D_8;
          h6_4 = E_8;
          h6_5 = F_8;
          h6_6 = G_8;
          h6_7 = H_8;
          goto h6;

      case 1:
          A_15 = h12_0;
          B_15 = h12_1;
          C_15 = h12_2;
          D_15 = h12_3;
          E_15 = h12_4;
          F_15 = h12_5;
          G_15 = h12_6;
          H_15 = h12_7;
          if (!(((H_15 % 2 + 2) % 2) == 0))
              abort ();
          h13_0 = A_15;
          h13_1 = B_15;
          h13_2 = C_15;
          h13_3 = D_15;
          h13_4 = E_15;
          h13_5 = F_15;
          h13_6 = G_15;
          h13_7 = H_15;
          G_16 = __VERIFIER_nondet_int ();
          A_16 = h13_0;
          B_16 = h13_1;
          C_16 = h13_2;
          D_16 = h13_3;
          E_16 = h13_4;
          F_16 = h13_5;
          I_16 = h13_6;
          H_16 = h13_7;
          if (!(I_16 == (G_16 + -1)))
              abort ();
          h14_0 = A_16;
          h14_1 = B_16;
          h14_2 = C_16;
          h14_3 = D_16;
          h14_4 = E_16;
          h14_5 = F_16;
          h14_6 = G_16;
          h14_7 = H_16;
          A_7 = h14_0;
          B_7 = h14_1;
          C_7 = h14_2;
          D_7 = h14_3;
          E_7 = h14_4;
          F_7 = h14_5;
          G_7 = h14_6;
          H_7 = h14_7;
          if (!1)
              abort ();
          h5_0 = A_7;
          h5_1 = B_7;
          h5_2 = C_7;
          h5_3 = D_7;
          h5_4 = E_7;
          h5_5 = F_7;
          h5_6 = G_7;
          h5_7 = H_7;
          A_8 = h5_0;
          B_8 = h5_1;
          C_8 = h5_2;
          D_8 = h5_3;
          E_8 = h5_4;
          F_8 = h5_5;
          G_8 = h5_6;
          H_8 = h5_7;
          if (!1)
              abort ();
          h6_0 = A_8;
          h6_1 = B_8;
          h6_2 = C_8;
          h6_3 = D_8;
          h6_4 = E_8;
          h6_5 = F_8;
          h6_6 = G_8;
          h6_7 = H_8;
          goto h6;

      case 2:
          A_18 = h12_0;
          B_18 = h12_1;
          C_18 = h12_2;
          D_18 = h12_3;
          E_18 = h12_4;
          F_18 = h12_5;
          G_18 = h12_6;
          H_18 = h12_7;
          if (!(!(((H_18 % 2 + 2) % 2) == 0)))
              abort ();
          h16_0 = A_18;
          h16_1 = B_18;
          h16_2 = C_18;
          h16_3 = D_18;
          h16_4 = E_18;
          h16_5 = F_18;
          h16_6 = G_18;
          h16_7 = H_18;
          A_6 = h16_0;
          B_6 = h16_1;
          C_6 = h16_2;
          D_6 = h16_3;
          E_6 = h16_4;
          F_6 = h16_5;
          G_6 = h16_6;
          H_6 = h16_7;
          if (!1)
              abort ();
          h5_0 = A_6;
          h5_1 = B_6;
          h5_2 = C_6;
          h5_3 = D_6;
          h5_4 = E_6;
          h5_5 = F_6;
          h5_6 = G_6;
          h5_7 = H_6;
          A_8 = h5_0;
          B_8 = h5_1;
          C_8 = h5_2;
          D_8 = h5_3;
          E_8 = h5_4;
          F_8 = h5_5;
          G_8 = h5_6;
          H_8 = h5_7;
          if (!1)
              abort ();
          h6_0 = A_8;
          h6_1 = B_8;
          h6_2 = C_8;
          h6_3 = D_8;
          h6_4 = E_8;
          h6_5 = F_8;
          h6_6 = G_8;
          h6_7 = H_8;
          goto h6;

      default:
          abort ();
      }
  h23:
    goto h23;

    // return expression

}

